# Giraffe.Fixi

[fixi](https://github.com/bigskysoftware/fixi) is a minimalist implementation of generalized hypermedia controls. It can be considered a very slimmed-down version of libraries like [htmx](https://htmx.org).

## Getting fixi and Giraffe.Fixi

fixi is designed to be vendored and served with an application. There are instructions on its page that detail how to obtain a copy. Once it is in your project, either ensure it is somewhere like `wwwroot`, or otherwise add it to your project file so that it will be included in your build.

As you are reading a NuGet package README, we will assume you know how to install this library.

## Using

On the server side, this library adds an `IsFixiRequest` property to `HttpContext`, which will return `true` if the request was generated from fixi.

In the view engine, each of fixi's six attributes have counterparts; for example, to generate an `fx-action` attribute, use `_fxAction`. Each of these take a string parameter, except for `_fxSwap`, which requires an instance of `FixiSwap`; and `_fxIgnore`, which requires no parameters at all.

Additionally, there are six attributes with the most common HTTP methods; using `_fxDelete`, `_fxHead`, `_fxGet`, `_fxPatch`, `_fxPost`, and `_fxPut` will be quicker (and less error-prone) than `_fxMethod "get"`, for example.

## Updating

This library was built in conjunction with fixi v0.5.7. Given the nature of its minimalist API, and the fact that there are no version-specific CDN links, this library will likely continue to work with future versions. (There may be more upgrades for .NET or Giraffe than will be required to change the fixi API.)
